<script setup lang="ts">
// ----------------------------------------------------------------
// Import
// ----------------------------------------------------------------

import { useMetadataStore } from "@/stores/useMetadataStore";
import jsonata from "jsonata";

// ----------------------------------------------------------------
// PROPS
// ----------------------------------------------------------------

const props = defineProps({
  addMetadataMappingDialog: {
    type: Boolean,
    required: true,
  },
  objectRelated: {
    type: Object,
    required: true,
  },
  dataAssociationID: {
    type: String,
    required: false,
  },
  metadataItems: {
    type: Object,
    required: true,
  },
});

// ----------------------------------------------------------------
// EMITS
// ----------------------------------------------------------------

const emits = defineEmits(["addMetadataMappingDialog", "newMetadata"]);

// ----------------------------------------------------------------
// Variables
// ----------------------------------------------------------------

const metadataStore = useMetadataStore();
const drawer = ref<boolean>(false);
const selectedMetadataFields = ref<any[]>([]);
const metadataDetails = ref<any | null>(null);
const mdfCount = ref(0);

const items = ref([]);
const open = ref([]);
const tree = ref([]);
const metadataFieldsMapping = ref(null);

const selectedItem = ref(null);
const activatedItem = ref(null);
const specificMetadataField = ref(null);

const notAdded = ref([]);
const notAddedModal = ref(false);

// ----------------------------------------------------------------
// Watch
// ----------------------------------------------------------------

watch(
  () => props.addMetadataMappingDialog,
  (newValue) => {
    if (newValue) {
      drawer.value = newValue;
    }
  },
);

// ----------------------------------------------------------------
// Lifecycle
// ----------------------------------------------------------------

// Fetch metadata when the component is mounted
onMounted(async () => {
  const { data: resConnectors } = await useAPIFetch("/api/connectors?type=submission_connector");
  items.value = resConnectors.value.results;

  for (let i = 0; i < items.value.length; i++) {
    const url = `/api/connectors/${items.value[i].name}/groups`;
    const { data: resGroup } = await useAPIFetch(url);
    if (resGroup.value.length > 0) {
      items.value[i].children = [];
    }

    items.value[i].id = items.value[i].name;
  }
});

// ----------------------------------------------------------------
// Functions
// ----------------------------------------------------------------

function close() {
  drawer.value = false;
  emits("addMetadataMappingDialog", false);
  selectedMetadataFields.value = [];
  metadataDetails.value = null;
  mdfCount.value = 0;
  selectedItem.value = null;
  activatedItem.value = null;
  specificMetadataField.value = null;
}

// Function to clear the list of selected metadata fields
function clearSelectedMetadataFields() {
  selectedMetadataFields.value = [];
}

// Add a metadata field to the selection list
function addMetadataField(field: any) {
  if (!selectedMetadataFields.value.find(item => item.id === field.id)) {
    selectedMetadataFields.value.push(field);
  }
}

// Add a metadata field to the selection list
function addMetadataFields() {
  if (metadataFieldsMapping.value) {
    for (const mf of metadataFieldsMapping.value) {
      if (mf.madbot_metadata_field.related_types.includes(props.objectRelated.type)) {
        // Check if the metadata field is already in the selected list and already used for a metadata of the current object
        if (!isSelected(mf.madbot_metadata_field) && !alreadyExist(mf.madbot_metadata_field.id)) {
          selectedMetadataFields.value = [...selectedMetadataFields.value, mf.madbot_metadata_field];
        }
      } else {
        notAdded.value.push(mf.madbot_metadata_field.name);
      }
    }
  }

  if (notAdded.value.length > 0) {
    notAddedModal.value = true;
  }
}

// Check if field is already selected
function isSelected(field: any) {
  return selectedMetadataFields.value.some(item => item.id === field.id);
}

// Check if metadata field id already exist for a metadata of the current object
function alreadyExist(id: any) {
  return props.metadataItems.some(metadataItem => metadataItem.id === id);
}

// Remove a metadata field from the selection list
function removeMetadataField(field: any) {
  selectedMetadataFields.value = selectedMetadataFields.value.filter(item => item !== field);
}

async function fetchGroup(item) {
  let url = "";

  if ("types" in item) {
    url = `/api/connectors/${item.name}/groups`;
  } else {
    url = `/api/connectors/${item.connector}/groups?parent=${item.name}`;
  }
  const { data: resGroup } = await useAPIFetch(url);
  item.children = resGroup.value;
  for (let i = 0; i < item.children.length; i++) {
    if ("groups" in item.children[i]) {
      item.children[i].children = [];
    }
    if ("types" in item) {
      item.children[i].connector = item.name;
    } else {
      item.children[i].connector = item.connector;
    }
    item.children[i].id = item.children[i].connector + item.children[i].slug;
  }
  return resGroup.value;
}

// Add the selected metadata fields
async function addSelectedMetadataFields() {
  for (const metadataField of selectedMetadataFields.value) {
    let value;
    if ("items" in metadataField.schema) {
      value = [];
    } else if ("type" in metadataField.schema && metadataField.schema.type === "object") {
      value = {};
    } else if ("type" in metadataField.schema && metadataField.schema.type === "boolean") {
      value = false;
    } else {
      value = "";
    }

    await metadataStore.createMetadata(
      metadataField.id,
      metadataField.source === "referential" ? "madbot" : "connector",
      value,
      props.objectRelated.id,
      props.objectRelated.type,
      props.objectRelated.datalinkID || undefined,
      props.dataAssociationID || undefined,
    );
  }
  emits("newMetadata", selectedMetadataFields.value);
  close();
}

// find an item from the items collection based on the provided item.id
// using a JSONata query and then sets selectedItem.value to this found item.
async function onItemSelected(item) {
  const expression = `**[id="${item[0].id}"]`;
  const result = await jsonata(expression).evaluate(items);
  selectedItem.value = result[0];
}

// handle the activation of an item by querying and updating relevant state values
async function onActivated(item) {
  if (item.length > 0) {
    activatedItem.value = null;
    specificMetadataField.value = null;
    const expression = `**[id="${item[0].id}"]`;

    const result = await jsonata(expression).evaluate(items.value);

    activatedItem.value = result;
    let connectorName;

    if ("types" in activatedItem.value) connectorName = activatedItem.value.name;
    else connectorName = activatedItem.value.connector;

    if (!("children" in activatedItem.value)) {
      let url = `/api/connectors/${connectorName}/metadata_mapping`;

      if (!("types" in activatedItem.value)) {
        url += `?group=${activatedItem.value.slug}`;
      }
      const { data: resGroup } = await useAPIFetch(url);

      if (resGroup.value.length > 0) {
        metadataFieldsMapping.value = resGroup.value;
      } else {
        metadataFieldsMapping.value = null;
      }
    } else {
      metadataFieldsMapping.value = null;
    }
  }
}
</script>

<template>
  <v-dialog
    v-model="drawer"
    width="100%"
    height="100%"
    style="max-width: 1250px !important; max-height: 800px !important"
    persistent
  >
    <v-card>
      <v-card-title class="d-flex">
        <v-sheet
          class="me-auto"
          style="
            overflow: hidden;
            white-space: nowrap;
            text-overflow: ellipsis;
            width: calc(100%-30);
          "
        >
          Add metadata by mapping
        </v-sheet>
        <v-sheet>
          <v-btn
            icon="$close"
            density="comfortable"
            variant="plain"
            @click="close"
          />
        </v-sheet>
      </v-card-title>

      <v-row>
        <v-col class="d-flex flex-column fill-height" style="max-width: 100%">
          <v-card-text>
            <div style="min-height: 480px; overflow-y: auto; max-height: 480px">
              <v-treeview
                v-model:opened="open"
                v-model:selected="tree"
                :items="items"
                item-title="name"
                item-id="id"
                item-key="id"
                item-value="id"
                :load-children="fetchGroup"
                density="compact"
                activatable
                return-object
                open-on-click
                @click:select="onItemSelected"
                @update:activated="onActivated"
              />
            </div>
            <div class="mt-2">
              <v-sheet class="d-flex align-center">
                <div class="w-100">
                  <v-card
                    v-bind="props"
                    :elevation="6"
                    class="mb-6 mx-1 pa-3 ml-2"
                    height="110"
                    max-height="110"
                    max-width="730"
                  >
                    <div class="d-flex justify-space-between align-center">
                      <h4>Selected metadata fields</h4>
                      <v-btn
                        v-if="selectedMetadataFields.length > 0"
                        size="x-small"
                        @click="clearSelectedMetadataFields"
                      >
                        Clear
                      </v-btn>
                    </div>
                    <v-container>
                      <v-row>
                        <v-col>
                          <v-chip-group>
                            <v-chip
                              v-for="field in selectedMetadataFields"
                              :key="field.name"
                              closable
                              @click:close="removeMetadataField(field)"
                            >
                              {{ field.name }}
                            </v-chip>
                          </v-chip-group>
                        </v-col>
                      </v-row>
                    </v-container>
                  </v-card>
                </div>
              </v-sheet>
            </div>
          </v-card-text>

          <v-btn
            class="ml-auto add-button"
            @click="addSelectedMetadataFields"
          >
            Add to metadata
            <span v-if="selectedMetadataFields.length > 0">
              ({{ selectedMetadataFields.length }})</span>
          </v-btn>
        </v-col>

        <v-divider class="mx-2 mb-6" vertical />
        <v-col
          cols="4"
          class="d-flex flex-column fill-height"
          style="max-width: 100%"
        >
          <div
            v-if="activatedItem && specificMetadataField === null"
            class="overflow-auto"
            style="height: 670px"
          >
            <v-row class="d-flex align-center">
              <v-card-title class="flex-grow-1 text-truncate" style="max-width: 340px">
                {{
                  activatedItem?.name
                }}
              </v-card-title>
              <v-btn
                v-if="metadataFieldsMapping"
                variant="text"
                class="clickable-icon pa-0 rounded-circle ml-auto mr-7"
                min-width="36"
                min-height="36"
                icon="mdi-basket-plus"
                density="comfortable"
                @click.stop="addMetadataFields"
              />
            </v-row>
            <br>
            <p>{{ activatedItem?.description }}</p>

            <div v-if="metadataFieldsMapping">
              <br>

              <p>
                <b>Metadata fields mapping ({{ metadataFieldsMapping.length }})</b>
              </p>
              <br>
              <div v-for="item of metadataFieldsMapping" :key="item.id">
                <v-row align="center" width="100%">
                  <v-col cols="4">
                    <span class="truncate-text" :title="item.metadata_field.name">
                      {{ item.metadata_field.name }}
                    </span>
                  </v-col>
                  <v-col cols="1" class="d-flex justify-center">
                    <v-icon>mdi-menu-right</v-icon>
                  </v-col>
                  <v-col cols="auto" class="mr-1">
                    <v-tooltip
                      :text="
                        `This metadata is not compatible with your current node (${
                          objectRelated.type
                        })`
                      "
                      :disabled="item.madbot_metadata_field.related_types.includes(objectRelated.type)"
                    >
                      <template v-slot:activator="{ props: basketProps }">
                        <v-chip
                          class="animated-chip mr-1"
                          v-bind="basketProps"
                          elevation="4"
                          style="max-width: 170px; width: 170px !important"
                          :variant="
                            item.madbot_metadata_field.related_types.includes(objectRelated.type)
                              ? 'outlined'
                              : 'tonal'
                          "
                          @click="specificMetadataField = item.madbot_metadata_field"
                        >
                          <span class="text-truncate" style="max-width: 150px">{{
                            item.madbot_metadata_field.name
                          }}</span>
                        </v-chip>
                        <v-btn
                          size="small"
                          icon="mdi-basket-plus"
                          :disabled="
                            !item.madbot_metadata_field.related_types.includes(objectRelated.type)
                              || isSelected(item.madbot_metadata_field)
                              || alreadyExist(item.madbot_metadata_field.id)
                          "
                          density="comfortable"
                          @click.stop="addMetadataField(item.madbot_metadata_field)"
                        />
                      </template>
                    </v-tooltip>
                  </v-col>
                </v-row>
              </div>
            </div>
          </div>
          <div v-if="specificMetadataField">
            <v-row class="d-flex align-center">
              <div class="d-flex me-auto">
                <v-btn
                  icon="mdi-arrow-left-thin"
                  density="comfortable"
                  variant="text"
                  @click="specificMetadataField = null"
                />

                <v-card-title class="text-truncate" style="max-width: 300px">
                  {{ specificMetadataField.name }}
                </v-card-title>
              </div>

              <v-tooltip
                :text="
                  `This metadata is not compatible with your current node (${
                    objectRelated.type
                  })`
                "
                :disabled="specificMetadataField?.related_types.includes(objectRelated.type)"
              >
                <template v-slot:activator="{ props: basketAllPros }">
                  <span v-bind="basketAllPros">
                    <v-btn
                      variant="text"
                      class="clickable-icon pa-0 rounded-circle ml-auto mr-7"
                      min-width="36"
                      min-height="36"
                      icon="mdi-basket-plus"
                      density="comfortable"
                      :disabled="
                        !specificMetadataField.related_types.includes(objectRelated.type)
                          || isSelected(specificMetadataField)
                          || alreadyExist(specificMetadataField.id)
                      "
                      @click.stop="addMetadataField(specificMetadataField)"
                    />
                  </span>
                </template>
              </v-tooltip>
            </v-row>
            <br>
            <p>{{ specificMetadataField.description }}</p>

            <h5>Associated with</h5>
            <div>
              <v-chip-group>
                <v-chip
                  v-for="(related_type, index) in specificMetadataField.related_types"
                  :key="index"
                  class="mr-1"
                >
                  {{ related_type }}
                </v-chip>
              </v-chip-group>
            </div>
          </div>
        </v-col>
      </v-row>
    </v-card>
    <v-dialog v-model="notAddedModal" width="auto">
      <v-card max-width="400" prepend-icon="mdi-alert-outline">
        <template v-slot:title>
          <span color="warning">Information</span>
        </template>
        <template v-slot:text>
          The following metadata cannot be associated in the object where you are located ({{
            objectRelated.type
          }}) and is therefore ignored: {{ notAdded.join() }}
        </template>
        <template v-slot:actions>
          <v-btn
            class="ms-auto"
            text="Ok"
            @click="
              notAddedModal = false;
              notAdded = [];
            "
          />
        </template>
      </v-card>
    </v-dialog>
  </v-dialog>
</template>

<style>
.add-button {
  margin-top: -20px;
  margin-bottom: 20px;
}
.v-dialog .v-card {
  height: 100%;
  overflow: hidden !important;
}
.animated-chip {
  transition:
    transform 0.2s,
    background-color 0.2s;
}
.animated-chip:hover {
  cursor: pointer;
  transform: scale(1.05);
}
.truncate-text {
  display: block;
  width: 100%;
  white-space: nowrap;
  overflow: hidden;
  text-overflow: ellipsis;
}
</style>
